# Pyntor::Video - Plays video
# Copyright (C) 2004 Josef Spillner <josef@coolprojects.org>
# Published under GNU GPL conditions

import pygame
from pygame.locals import *
import sys
import time
import random
import os, pwd

class Video:
	def __init__(self):
		pass

	def run(self, options):
		""" Options """

		videofile = options[0]
		if len(options) > 1:
			preview = 1
		else:
			preview = 0

		pygame.mixer.quit()

		try:
			video = pygame.movie.Movie(videofile)
		except:
			pygame.mixer.init()
			video = pygame.movie.Movie(videofile)

		""" Screen setup """

		screen = pygame.display.get_surface()

		screencopy = pygame.Surface((screen.get_width(), screen.get_height()))
		screencopy.blit(screen, (0, 0))

		surface = pygame.Surface((screen.get_width(), screen.get_height()))
		surface.blit(screen, (0, 0))

		pygame.event.clear()

		#print "START"

		size = video.get_size()
		vsurface = pygame.Surface(size)
		video.set_display(vsurface)
		#video.set_display(screen)

		video.set_volume(1.0)

		while 1:
			""" Control """

			pygame.event.pump()
			event = pygame.event.poll()
			if event.type == KEYDOWN:
				key = event.key
				if key == K_ESCAPE or pygame.event.peek(QUIT):
					break
				if key == K_RETURN:
					break
				if key == K_s:
					filename = "video" + ".bmp"
					pygame.image.save(screen, os.path.join("static", filename))
				if key == K_RIGHT:
					video.skip(10.0)
				if key == K_UP:
					video.skip(50.0)

				if key == K_v:
					screen.blit(screencopy, (0, 0))
					preview = 1 - preview

			""" Drawing """

			#print "PLAY"

			video.play()

			#(width, height) = size
			#xsurface = pygame.transform.scale(vsurface, (width * 2, height * 2))
			if preview:
				xsurface = pygame.transform.scale(vsurface, (200, 150))
				screen.blit(xsurface, (412, 500))
			else:
				xsurface = pygame.transform.scale(vsurface, (1024, 768))
				screen.blit(xsurface, (0, 0))
			#screen.blit(vsurface, (0, 0))
			#screen.blit(surface, (0, 0))
			#pygame.display.update()
			pygame.display.flip()

		screen.blit(screencopy, (0, 0))

component = Video()

